package com.yidian.common

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.TextView
import com.amap.api.services.core.PoiItem

/**
 * Author: sym
 * Date: 2021/6/27 3:35 PM
 * Describe:
 */
class PoiListAdapter : BaseAdapter() {
  private lateinit var data: List<PoiItem>

  override fun getCount(): Int {
    return if (::data.isInitialized) {
      data.size
    } else {
      0
    }
  }

  override fun getItem(position: Int): Any {
    return position
  }

  override fun getItemId(position: Int): Long {
    return position.toLong()
  }

  override fun getView(position: Int, convertView: View?, parent: ViewGroup?): View {
    val view: View?

    var holder: ViewHolder
    if (convertView == null) {
      holder = ViewHolder()
      view = LayoutInflater.from(parent!!.context).inflate(R.layout.list_view_item, null)
      holder.titleTextView = view.findViewById(R.id.list_view_title_text)
      holder.areaTextView = view.findViewById(R.id.list_view_area_text)
      view.tag = holder

    } else {
      view = convertView
      holder = view.tag as ViewHolder
    }
    //填充数据
    holder.titleTextView!!.text = data[position].title
    holder.areaTextView!!.text = data[position].provinceName + data[position].cityName + data[position].adName
    return view!!
  }

  internal class ViewHolder {
    var titleTextView: TextView? = null
    var areaTextView: TextView? = null
  }

  fun setData(data: List<PoiItem>) {
    this.data = data
    notifyDataSetChanged()
  }
}
