package com.yidian.shenghuoquan.newscontent.ui

import android.content.Intent
import android.os.Bundle
import android.view.KeyEvent
import android.widget.AdapterView
import com.amap.api.services.core.AMapException
import com.amap.api.services.core.PoiItem
import com.amap.api.services.poisearch.PoiResult
import com.amap.api.services.poisearch.PoiSearch
import com.amap.api.services.poisearch.PoiSearch.OnPoiSearchListener
import com.yidian.common.PoiSearchAdapter
import com.yidian.common.base.BaseActivity
import com.yidian.shenghuoquan.newscontent.databinding.LayoutActivityServiceProductAddrSearchBinding

/**
 * Author: sym
 * Date: 2021/6/28 2:55 PM
 * Describe:
 */
class SearchAddActivity : BaseActivity<LayoutActivityServiceProductAddrSearchBinding>(), OnPoiSearchListener {
  private var adapter = PoiSearchAdapter()
  private var resultIntent = Intent()
  private var key = ""
  private lateinit var data: List<PoiItem>
  override fun createViewBinding(): LayoutActivityServiceProductAddrSearchBinding {
    return LayoutActivityServiceProductAddrSearchBinding.inflate(layoutInflater)
  }

  override fun getXPageName(): String {
    return ""
  }

  override fun init(savedInstanceState: Bundle?) {
    super.init(savedInstanceState)
    viewBind.poiSearchList.adapter = adapter
    viewBind.poiSearchList.onItemClickListener = AdapterView.OnItemClickListener { _, _, position, _ ->
      resultIntent.putExtra("title", data[position].title)
      resultIntent.putExtra("cityName", data[position].cityName)
      resultIntent.putExtra("adName", data[position].adName)
      resultIntent.putExtra("latLonPoint", data[position].latLonPoint)
      setResult(100, resultIntent)
      finish()
    }


    viewBind.btnHeaderRight.setOnClickListener {
      finish()
    }
    viewBind.etLaspasSearchKey.setOnKeyListener { p0, keyCode, event ->
      if (event!!.action == KeyEvent.ACTION_DOWN && keyCode == KeyEvent.KEYCODE_ENTER) {
        queryPoi()
      }
      false
    }
  }

  override fun onPoiSearched(poiResult: PoiResult?, rCode: Int) {
    if (rCode == AMapException.CODE_AMAP_SUCCESS) {
      if (poiResult?.query != null) {
        val poiItems: List<PoiItem> = poiResult.pois // 取得第一页的poiitem数据，页数从数字0开始
        if (poiItems != null && poiItems.isNotEmpty()) {
          adapter.setData(poiItems)
          data = poiItems
        }
      }
    }
  }

  override fun onPoiItemSearched(p0: PoiItem?, p1: Int) {
    TODO("Not yet implemented")
  }

  //poi搜索
  private fun queryPoi() {
    val typeRange = "汽车服务|汽车销售|" +
      "汽车维修|摩托车服务|餐饮服务|购物服务|生活服务|体育休闲服务|医疗保健服务|" +
      "住宿服务|风景名胜|商务住宅|政府机构及社会团体|科教文化服务|交通设施服务|" +
      "金融保险服务|公司企业|道路附属设施|地名地址信息|公共设施"
    key = viewBind.etLaspasSearchKey.text.toString()
    val query = PoiSearch.Query(key, typeRange, "北京")
    query.pageSize = 1000 // 设置每页最多返回多少条poiitem
    query.pageNum = 1 //设置查第一页
    val poiSearch = PoiSearch(this, query)
    poiSearch.setOnPoiSearchListener(this) //设置数据返回的监听器
    poiSearch.searchPOIAsyn()
  }


}
